#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
import math

class Point:
    """
    >>> p = Point(3, 4)
    >>> p.log()
    5.0
    >>> p.move(2, 8)
    >>> p.log()
    13.0
    """
    x = 0
    y = 0
    
    def __init__(self, x, y):
        self.x = x
        self.y = y
        
    def move(self, dx, dy):
        self.x += dx
        self.y += dy
        
    def log(self):
        print(self.dis)

    @property    #pull dis = math.sqrt(x ** 2 + y ** 2)
    def dis(self):
        return math.sqrt(self.x ** 2 + self.y ** 2)

if __name__ == "__main__":
    import doctest
    doctest.testmod()
