#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
class Test:
    """
    >>> t = Test()
    >>> t.printB()
    b = 1
    >>> t.printC()
    c = 2
    >>> t.setA(2)
    setA: 2
    >>> t.printC()
    c = 2
    >>> t.printB()
    b = 3
    >>> t.setA(3)
    setA: 3
    >>> t.printB()
    b = 4
    >>> t.printC()
    c = 5
    """
    def _puppy_wrapper_b(f): #0
        def wrapper(self):
            self._puppy_field_b = f(self)
            self._puppy_update_c()
            return self._puppy_field_b
        return wrapper
    
    _puppy_field_b = 0    #pupull b = a + 1 #1

    a = 0 #2
            
    def setA(self, na): #3
        print("setA:", na)
        self.a = na
        
    def printB(self): #4
        print("b =", self.b)
        
    def printC(self): #5
        print("c =", self.c)

    @property #6
    @_puppy_wrapper_b
    def b(self):
        return self.a + 1

    def _puppy_update_c(self): #7
        self.c = self._puppy_field_b + 1

    c = _puppy_field_b + 1    #pupush c = b + 1 #8

if __name__ == "__main__":
    import doctest
    doctest.testmod()
